summaryrefslogtreecommitdiff
path: root/git-request-pull.sh
diff options
context:
space:
mode:
Diffstat (limited to 'git-request-pull.sh')
-rwxr-xr-xgit-request-pull.sh80
1 files changed, 63 insertions, 17 deletions
diff --git a/git-request-pull.sh b/git-request-pull.sh
index 4eacc3a059..6fdea397dd 100755
--- a/git-request-pull.sh
+++ b/git-request-pull.sh
@@ -1,33 +1,79 @@
-#!/bin/sh -e
+#!/bin/sh
# Copyright 2005, Ryan Anderson <ryan@michonline.com>
#
# This file is licensed under the GPL v2, or a later version
# at the discretion of Linus Torvalds.
-USAGE='<commit> <url> [<head>]'
-LONG_USAGE='Summarizes the changes since <commit> to the standard output,
-and includes <url> in the message generated.'
+USAGE='<start> <url> [<end>]'
+LONG_USAGE='Summarizes the changes between two commits to the standard output,
+and includes the given URL in the generated summary.'
SUBDIRECTORY_OK='Yes'
+OPTIONS_KEEPDASHDASH=
+OPTIONS_SPEC='git request-pull [options] start url [end]
+--
+p show patch text as well
+'
+
. git-sh-setup
+. git-parse-remote
+
+GIT_PAGER=
+export GIT_PAGER
+
+patch=
+while case "$#" in 0) break ;; esac
+do
+ case "$1" in
+ -p)
+ patch=-p ;;
+ --)
+ shift; break ;;
+ -*)
+ usage ;;
+ *)
+ break ;;
+ esac
+ shift
+done
-revision=$1
+base=$1
url=$2
head=${3-HEAD}
-[ "$revision" ] || usage
+[ "$base" ] || usage
[ "$url" ] || usage
-baserev=`git-rev-parse --verify "$revision"^0` &&
-headrev=`git-rev-parse --verify "$head"^0` || exit
+baserev=`git rev-parse --verify "$base"^0` &&
+headrev=`git rev-parse --verify "$head"^0` || exit
+
+merge_base=`git merge-base $baserev $headrev` ||
+die "fatal: No commits in common between $base and $head"
+
+branch=$(git ls-remote "$url" \
+ | sed -n -e "/^$headrev refs.heads./{
+ s/^.* refs.heads.//
+ p
+ q
+ }")
+url=$(get_remote_url "$url")
+if [ -z "$branch" ]; then
+ echo "warn: No branch of $url is at:" >&2
+ git log --max-count=1 --pretty='tformat:warn: %h: %s' $headrev >&2
+ echo "warn: Are you sure you pushed $head there?" >&2
+ echo >&2
+ echo >&2
+ branch=..BRANCH.NOT.VERIFIED..
+ status=1
+fi
+
+git show -s --format='The following changes since commit %H:
-echo "The following changes since commit $baserev:"
-git log --max-count=1 --pretty=short "$baserev" |
-git-shortlog | sed -e 's/^\(.\)/ \1/'
+ %s (%ci)
-echo "are found in the git repository at:"
-echo
-echo " $url"
-echo
+are available in the git repository at:' $baserev &&
+echo " $url $branch" &&
+echo &&
-git log $baserev..$headrev | git-shortlog ;
-git diff -M --stat --summary $baserev..$headrev
+git shortlog ^$baserev $headrev &&
+git diff -M --stat --summary $patch $merge_base..$headrev || exit
+exit $status